var g_AudioSupported = false;
var g_toggleLightModus  =0;
var g_toggleAudioModus  =0;
var g_toggleRefreshModus=0;
var g_toggleImgSizeModus=0;
var g_toggleLight    ="unpressed";
var g_toggleRefresh  ="unpressed";
var g_toggleAudio    ="unpressed";
var g_toggleImageSize="unpressed";
var g_toggleInfo="hidden";
var g_updateStateLight    = "unpressed";
var g_updateStateLightAlt = "unpressed";
var g_request = null;
var g_currentRes = 0;
var g_picture_small = true;
var g_lastImageSize = null;

function sendControlCmd(key, value) {

    if (g_request) {
        g_request.abort();
    }

    var param = key + "=" + value;
    var g_request = $.ajax({
        url: "control",
        type: "post",
        data: param,
        contentType: "application/x-www-form-urlencoded; charset=UTF-8"
     });

     g_request.done(function (response, textStatus, jqXHR){
     });

     g_request.fail(function (jqXHR, textStatus, errorThrown){
     });
  }

function setupTitle() {

     var request = $.ajax({
        url: "stats",
        type: "post",
        data: "getTitle=1",
        contentType: "application/x-www-form-urlencoded; charset=UTF-8"
     });

     request.done(function (response, textStatus, jqXHR){
         if (response == "")
             response = "&nbsp;";
         $("#camTitle").html(response);
     });

     request.fail(function (jqXHR, textStatus, errorThrown){
     });
}

function setupFboxName() {

     var request = $.ajax({
        url: "stats",
        type: "post",
        data: "getFboxName=",
        contentType: "application/x-www-form-urlencoded; charset=UTF-8"
     });

     request.done(function (response, textStatus, jqXHR){
         if (response == "")
             response = "&nbsp;";
         $("#boxTitle").html(response);
     });

     request.fail(function (jqXHR, textStatus, errorThrown){
     });
}

function setupLogout() {

    $("#logout").hide();
    var request = $.ajax({
       url: "stats",
       type: "post",
       data: "getNeedLogin=",
       contentType: "application/x-www-form-urlencoded; charset=UTF-8"
    });

    request.done(function (response, textStatus, jqXHR){
        if (response == "YES")
            $("#logout").show();
    });

    request.fail(function (jqXHR, textStatus, errorThrown){
    });
}

function jsonResultsCallback(jsonobj) {
    var light = jsonobj['cameraLight'];
    var camfps = jsonobj[ 'cameraFPS' ];
    var imgqu = jsonobj['cameraImgQuality'];
    var imgres = jsonobj['cameraImgResolution'];
    var imgsize = jsonobj['cameraImgSize'];
    var numvis = jsonobj['visitorsCount'];
    var day = jsonobj['dateDay'];
    var time = jsonobj['dateTime'];
    var appversion = jsonobj['appVersion'];
    $("#uiViewerCnt").html(numvis);
    $("#uiTime").html(day + " - " + time);
    $("#uiAppVersion").html(appversion);
    $("td#idTraceQ").text("<!--@Bildqualität@--> " + (100 - (g_currentRes*20)) + "%");
    setCameraFPS(camfps);
    setRes(imgqu);
    g_updateStateLight = (light=="on" ? "pressed" : "unpressed");
    updateChangeLightPicture();
    if (imgsize != g_lastImageSize)
        changeImageSize(imgsize);
    g_lastImageSize = imgsize;
    if (!isAudioSupportEnabled()) {
        g_AudioSupported = false;
        change_text("uiAudioTxt", "<!--@Kein Ton@-->");
    }
}

function updateState() {
    if (isWebSocketSupported()) {
        requestState(function(data) {
            var jsonobj = $.parseJSON(data);
            if (!jsonobj)
                return;
            jsonResultsCallback(jsonobj);
        });
        return;
    }
    $.ajax({
       url: "stats",
       type: "post",
       data: "getState=",
       dataType: "json",
       success: jsonResultsCallback
    });
}

function changeImageSize(imgsize)
{
    var pictureSmall = "public/images/icon_picture_small.png";
    var pictureBig   = "public/images/icon_picture_big.png";

    $("#uiPage").removeClass("page_content_800");
    $("#uiPage").removeClass("page_content_1024");
    $("#uiPage").removeClass("page_content_1280");
    var a = imgsize.split(",");
    a = Math.max(Number(a[0]), Number(a[1]));
    switch(a)
    {
      case 640:
        $("#uiPage").addClass("page_content_800");
        $("#uiSlider div.slider").css("left","35px");
        change_picture("uiImgSize",pictureBig);
       break;
      case 1024:
        $("#uiPage").addClass("page_content_1024");
        $("#uiSlider div.slider").css("left","35px");
        change_picture("uiImgSize",pictureSmall);
       break;
      case 1280:
        $("#uiPage").addClass("page_content_1280");
        $("#uiSlider div.slider").css("left","60px");
        change_picture("uiImgSize",pictureSmall);
       break;
      default:
        $("#uiSlider div.slider").css("left","0px");
        change_picture("uiImgSize",pictureSmall);
    }
}

var gLastSockUpdateTime = new Date().getTime();
var gLastBandwidth = 0;
function updateBandwidthDisplay() {
    var socketbytes = getCountSocketBytes();
    var now = ( new Date() ).getTime();
    resetCountSocketBytes();
    socketbytes /= ( now - gLastSockUpdateTime );
    gLastSockUpdateTime = now;
    var sockbandwidth = gLastBandwidth * 0.3 + socketbytes * 0.7;
    gLastBandwidth = sockbandwidth;
    $("#uiBandwidth").html("" + (sockbandwidth/1000.0).toFixed(2) + " MB/s");
}

function periodicUpdate() {
    updateState();
    updateBandwidthDisplay();
    $("#uiFrameCnt").html("" + getFPS());
    window.setTimeout(periodicUpdate, 2*1000);
}

function connectionRecoverCallback() {
    if (isWebSocketSupported()) {
        setWSConnectionCallback(function() {
            if (g_AudioSupported && (g_toggleAudioModus == 0)) {
                enableAudioTransmission(true);
            }
            updateImage();
        });
        createSocket(null);
    }
    else {
        updateImage();
    }
}

$(document).ready( function() {
    $("#logout").hide();

    $("#uiToggleLight a").mousedown(function(event){

       mousedownToggle("uiToggleLight",this);
    });
    $("#uiToggleLight a").mouseup(function(event){

       mouseupToggle("uiToggleLight",this);
    });

    $("#uiToggleAudio a").mousedown(function(event){

        mousedownToggle("uiToggleAudio",this);
     });
    $("#uiToggleAudio a").mouseup(function(event){

        mouseupToggle("uiToggleAudio",this);
     });

    $("#uiToggleRefresh a").mousedown(function(event){

       mousedownToggle("uiToggleRefresh",this);
    });
    $("#uiToggleRefresh a").mouseup(function(event){

       mouseupToggle("uiToggleRefresh",this);
    });


    $("#uiToggleImageSize a").mousedown(function(event){

       mousedownToggle("uiToggleImageSize",this);
    });
    $("#uiToggleImageSize a").mouseup(function(event){

       mouseupToggle("uiToggleImageSize",this);
    });

    $("#uiAnimatedSnapshot a").mousedown(function(event){

       mousedownAnimation("uiAnimatedSnapshot",this);
    });
    $("#uiAnimatedSnapshot a").mouseup(function(event){

       mouseupAnimation("uiAnimatedSnapshot",this);
    });


    $("#uiAnimatedAutoFocus a").mousedown(function(event){

       mousedownAnimation("uiAnimatedAutoFocus",this);
    });
    $("#uiAnimatedAutoFocus a").mouseup(function(event){

       mouseupAnimation("uiAnimatedAutoFocus",this);
    });

    $("#uiBtnGalerie a").mousedown(function(event){

       mousedownNormal("uiBtnGalerie",this);
    });
    $("#uiBtnGalerie a").mouseup(function(event){

       mouseupNormal("uiBtnGalerie",this);
    });

    $("#uiBtnHelp a").mousedown(function(event){

       mousedownNormal("uiBtnHelp",this);
    });
    $("#uiBtnHelp a").mouseup(function(event){

       mouseupNormal("uiBtnHelp",this);
    });

    $("#uiBtnInfo div a").mousedown(function(event){
       mousedownNormal("uiBtnInfo",this);
    });
    $("#uiBtnInfo div a").mouseup(function(event){
       mouseupNormal("uiBtnInfo",this);
    });

    $("#uiQualityLow a").mousedown(function(event){
       mousedownNormal("uiQualityLow",this);
    });
    $("#uiQualityLow a").mouseup(function(event){
       mouseupNormal("uiQualityLow",this);
    });

    $("#uiQualityHigh a").mousedown(function(event){
       mousedownNormal("uiQualityHigh",this);
    });
    $("#uiQualityHigh a").mouseup(function(event){
       mouseupNormal("uiQualityHigh",this);
    });

    setupTitle();
    setupFboxName();
    setupLogout();
    if(isWebSocketSupported()) {
        setWSConnectionCallback(function() {
            window.setTimeout(periodicUpdate, 2*1000);
            enableAudioTransmission(true);
            updateImage();
        });
        createSocket(null);
    }
    else {
        window.setTimeout(periodicUpdate, 2*1000);
        updateImage();
    }
    setConnectionRecoveryCallback(connectionRecoverCallback);
    g_AudioSupported = isAudioSupportReady();
    if (!g_AudioSupported)
        change_text("uiAudioTxt", "<!--@Kein Ton@-->");
});

function updateChangeLightPicture()
{
  if(g_updateStateLightAlt != g_updateStateLight)
  {
      var picture   = (g_updateStateLight == "unpressed" ? "public/images/icon_light_off.png": "public/images/icon_light_on.png");
      change_picture("uiLight",picture);
      if(g_updateStateLight == "pressed")
      {
         g_toggleLightModus = 1;
         g_toggleLight      = "pressed";
         $("#uiToggleLight").removeClass("asButton");
         $("#uiToggleLight").removeClass("btnstate_unpressed");
         $("#uiToggleLight").addClass("btnstate_toggled");
      }
      else
      {
         g_toggleLight      = "unpressed";
         g_toggleLightModus = 0;
         $("#uiToggleLight").addClass("asButton");
         $("#uiToggleLight").removeClass("btnstate_toggled");
         $("#uiToggleLight").addClass("btnstate_unpressed");
      }
      g_updateStateLightAlt = g_updateStateLight;
  }
}


function mousedownToggle(id,ctx)
{
   var toggleModus;
   var pictureOn;
   var pictureOff;
   switch(id)
   {
      case "uiToggleLight":
           toggleModus = g_toggleLightModus;
           pictureOn   = "public/images/icon_light_on.png";
           pictureOff  = "public/images/icon_light_off.png";
           break;
      case "uiToggleAudio":
          if (g_AudioSupported) {
              toggleModus = g_toggleAudioModus;
              pictureOn   = "public/images/icon_audio_on.png";
              pictureOff  = "public/images/icon_audio_off.png";
          }
          break;
      case "uiToggleRefresh":
           toggleModus = g_toggleRefreshModus;
           pictureOn   = "public/images/icon_refresh_on.png";
           pictureOff  = "public/images/icon_refresh_off.png";
           break;
      case "uiToggleImageSize":
           toggleModus = g_toggleImgSizeModus;
           pictureOn   = "public/images/icon_picture_small.png";
           pictureOff  = "public/images/icon_picture_big.png";
           break;
      default:
   }
   if(toggleModus == 0)
   {
          $(ctx).parent().parent().find("td#"+id).removeClass("asButton");

           switch(id)
           {
              case "uiToggleLight":
                    sendControlCmd("light", "on");
                    break;
              case "uiToggleAudio":
                  if (g_AudioSupported) {
                      g_toggleAudio      = "pressed";
                      g_toggleAudioModus = 1;
                      change_picture("uiAudio",pictureOff);
                      change_text("uiAudioTxt", "<!--@Ton an@-->");
                      enableAudioTransmission(false);
                  }
                  break;
              case "uiToggleRefresh":
                    g_toggleRefresh      = "pressed";
                    g_toggleRefreshModus = 1;
                    change_picture("uiRefresh",pictureOn);
                    change_text("uiRefreshTxt", "<!--@weiter@-->");
                    enableImageUpating(false);
                    break;
              case "uiToggleImageSize":
                    g_toggleRefresh        = "pressed";
                    g_toggleImgSizeModus = 1;
                    change_picture("uiImgSize",pictureOn);
                    if(g_picture_small)
                    {
                      sendControlCmd("imageSize", "big");
                      g_picture_small = false;
                    }
                    else
                    {
                      sendControlCmd("imageSize", "small");
                      g_picture_small = true;
                    }
                    break;
              default:
           }
          $(ctx).parent().parent().find("td#"+id).removeClass("btnstate_unpressed");
          $(ctx).parent().parent().find("td#"+id).addClass("btnstate_pressed");
   }
   else
   {
      if(id != "uiToggleImageSize") $(ctx).parent().parent().find("td#"+id).removeClass("btnstate_toggled");
      $(ctx).parent().parent().find("td#"+id).addClass("btnstate_pressed");

       switch(id)
       {
          case "uiToggleLight":
                sendControlCmd("light", "off");
                break;
             case "uiToggleAudio":
              if (g_AudioSupported) {
                  g_toggleAudio      = "unpressed";
                  g_toggleAudioModus = 0;
                  change_picture("uiAudio",pictureOn);
                  change_text("uiAudioTxt", "<!--@Ton aus@-->");
                  enableAudioTransmission(true);
              }
              break;
             case "uiToggleRefresh":
                 g_toggleRefresh      = "unpressed";
                 g_toggleRefreshModus = 0;
                 change_picture("uiRefresh",pictureOff);
                 change_text("uiRefreshTxt", "<!--@Bild anhalten@-->");
                 enableImageUpating(true);
                 break;
          case "uiToggleImageSize":
                g_toggleImageSize      = "unpressed";
                g_toggleImgSizeModus = 0;
                change_picture("uiImgSize",pictureOff);
                if(g_picture_small)
                {
                  sendControlCmd("imageSize", "big");
                  g_picture_small = false;
                }
                else
                {
                  sendControlCmd("imageSize", "small");
                  g_picture_small = true;
                }
                break;
          default:
       }
   }
}

function mouseupToggle(id,ctx)
{
   var toggleModus;
   switch(id)
   {
      case "uiToggleLight":
           toggleModus = g_toggleLightModus;
           break;
      case "uiToggleAudio":
          toggleModus = g_toggleAudioModus;
          break;
      case "uiToggleRefresh":
           toggleModus = g_toggleRefreshModus;
           break;
      case "uiToggleImageSize":
           toggleModus = g_toggleImgSizeModus;
           break;
      default:
   }

   if(toggleModus == 1)
   {
       $(ctx).parent().parent().find("td#" + id).removeClass("btnstate_pressed");
       if(id != "uiToggleImageSize") $(ctx).parent().parent().find("td#" + id).addClass("btnstate_toggled");
   }
   else
   {
       $(ctx).parent().parent().find("td#" + id).addClass("asButton");
       if(id != "uiToggleImageSize") $(ctx).parent().parent().find("td#" + id).removeClass("btnstate_toggled");
       $(ctx).parent().parent().find("td#" + id).addClass("btnstate_unpressed");
   }

}

function mousedownAnimation(id,ctx)
{
      $(ctx).parent().parent().find("td#"+id).removeClass("asButton");
      $(ctx).parent().parent().find("td#"+id).removeClass("btnstate_unpressed");
      $(ctx).parent().parent().find("td#"+id).addClass("btnstate_pressed");

}

function mouseupAnimation(id,ctx)
{
   var pictureAnimated = (id == "uiAnimatedSnapshot" ? "public/images/ani_snapshot.gif": "public/images/ani_autofocus.gif");

   if(id == "uiAnimatedSnapshot")
   {
       sendControlCmd("snapshot", "");
       change_picture("uiSnapshot",pictureAnimated);
   }
   else
   {
       sendControlCmd("focus", "");
       change_picture("uiAutoFocus",pictureAnimated);
   }
   $(ctx).parent().parent().find("td#" + id).addClass("asButton");
   $(ctx).parent().parent().find("td#" + id).removeClass("btnstate_pressed");
   $(ctx).parent().parent().find("td#" + id).addClass("btnstate_unpressed");
}

function mousedownNormal(id,ctx)
{
   switch(id)
   {
      case "uiQualityHigh":
      case "uiQualityLow":
           $(ctx).parent().parent().find("div#"+id).removeClass("asDivButton");
           $(ctx).parent().parent().find("div#"+id).removeClass("btnDivState_unpressed");
           $(ctx).parent().parent().find("div#"+id).addClass("btnDivState_pressed");
           break;
      case "uiBtnGalerie":
      case "uiBtnHelp":
          $(ctx).parent().parent().find("td#"+id).removeClass("asButton");
          $(ctx).parent().parent().find("td#"+id).removeClass("btnstate_unpressed");
          $(ctx).parent().parent().find("td#"+id).addClass("btnstate_pressed");
           break;
      case "uiBtnInfo":
          $(ctx).parent().parent().parent().parent().find("td#"+id).removeClass("asButton");
          $(ctx).parent().parent().parent().parent().find("td#"+id).removeClass("btnstate_unpressed");
          $(ctx).parent().parent().parent().parent().find("td#"+id).addClass("btnstate_pressed");
           break;
      default:
   }

}

function mouseupNormal(id,ctx)
{
   switch(id)
   {
      case "uiQualityHigh":
      case "uiQualityLow":
           $(ctx).parent().parent().find("div#"+id).addClass("asDivButton");
           $(ctx).parent().parent().find("div#"+id).removeClass("btnDivState_pressed");
           $(ctx).parent().parent().find("div#"+id).addClass("btnDivState_unpressed");
           break;
      case "uiBtnGalerie":
           $(ctx).parent().parent().find("td#" + id).addClass("asButton");
           $(ctx).parent().parent().find("td#" + id).removeClass("btnstate_pressed");
           $(ctx).parent().parent().find("td#" + id).addClass("btnstate_unpressed");
           window.open("gallery.html");
           break;
      case "uiBtnHelp":
           $(ctx).parent().parent().find("td#" + id).addClass("asButton");
           $(ctx).parent().parent().find("td#" + id).removeClass("btnstate_pressed");
           $(ctx).parent().parent().find("td#" + id).addClass("btnstate_unpressed");
           window.open("<!--@Hilfelink@-->");
           break;
      case "uiBtnInfo":
           $(ctx).parent().parent().parent().parent().find("td#" + id).addClass("asButton");
           $(ctx).parent().parent().parent().parent().find("td#" + id).removeClass("btnstate_pressed");
           $(ctx).parent().parent().parent().parent().find("td#" + id).addClass("btnstate_unpressed");
           break;
      default:
   }
}

var classNameCache = {};
var reTrim = /^\s+|\s+$/g;
var reWhitespace = /\s+/g;

function classNameRegExp(strClass) {
  if (!classNameCache[strClass]) {
    classNameCache[strClass] = new RegExp('(?:^|\\s+)' + strClass + '(?:\\s+|$)');
  }
  return classNameCache[strClass];
}
function normalizeClassName(str) {
  str = str.replace(reTrim, "");
  str = str.replace(reWhitespace, " ");
  return str;
}

function change_picture(idOrElement,picturePath)
{
  var elem = window.document.getElementById(idOrElement);
  if (elem)
    elem.src=picturePath;
}
function change_text(idOrElement,newtext)
{
  var elem = window.document.getElementById(idOrElement);
  if (elem)
    elem.innerHTML=newtext;
}

function setRes(resolution)
{
    var res=5-Math.floor(resolution/20);
    if (res!=g_currentRes)
    {
      $("div.slider div#uiQualityMarker").removeClass("pos"+g_currentRes);
      $("div.slider div#uiQualityMarker").addClass("pos"+res);
      g_currentRes=res;
    }
}
function OnLowerRes()
{
  var old=g_currentRes;
  old+=1;
  if (old>5)
      old=5;
  sendControlCmd("imageQuality", "" + 100 - (old * 20));
}
function OnHigherRes()
{
  var old=g_currentRes;
  old-=1;
  if (old<0)
      old=0;
  sendControlCmd("imageQuality", "" + 100 - (old * 20));
}
function OnInfoToggle()
{
  var old=g_toggleInfo;
  g_toggleInfo=(g_toggleInfo=="hidden")?"visible":"hidden";
  if (old!=g_toggleInfo)
  {
    $("div#uiInfoArea").removeClass("wndstate_"+old);
    $("div#uiInfoArea").addClass("wndstate_"+g_toggleInfo);
  }
  change_picture("uiInfoCtrl",(g_toggleInfo=="hidden")?"public/images/icon_open.png":"public/images/icon_close.png");
}
