var g_UseWS = false;
var g_tohide = 1;
var g_toshow = 0;
var g_imageUpdating = true;
var g_imageUpdatingWdTimeout = 5000;
var g_imageUpdatingWdRetries = 0;
var g_imageCurrentURL = "";
var g_connectionRequest = null;
var g_lastTime = ( new Date() ).getTime();
var g_fps = 1.0;
var g_cameraImgPeriod = 1000;
var g_connectionRecoveryCallback = null;


function setConnectionRecoveryCallback(cb) {
	g_connectionRecoveryCallback = cb;
}

function setCameraFPS(fps) {
	g_cameraImgPeriod = 1000.0 / fps;
}

function getFPS() {
	return g_fps.toFixed(1);
}

function enableImageUpating(enable) {
	if (enable && (enable != g_imageUpdating)) {
		g_imageUpdating = true;
		g_lastTime = ( new Date() ).getTime();
		updateImage();
	}
	g_imageUpdating = enable;
}

function onConnectionLoss() {
	g_fps = 0;
	if (!g_imageUpdating)
		return;

	if (g_connectionRequest != null)
		g_connectionRequest.abort();

	g_connectionRequest = $.ajax({
		url: g_imageCurrentURL,
		success: function(response) {
			g_connectionRequest = null;
			if (g_connectionRecoveryCallback)
				g_connectionRecoveryCallback();
			g_imageUpdatingWdRetries = 0;
			g_lastTime = ( new Date() ).getTime();
		},
		error: function(xhr, ajaxOptions, thrownError) {
			g_imageUpdatingWdRetries++;
			g_connectionRequest = null;
			if (g_imageUpdatingWdRetries < 12)
				window.setTimeout(onConnectionLoss, g_imageUpdatingWdTimeout);
		}
	});
}

function updateImage() {

	var now = new Date();
	var requesttime = now.getTime();
	var deltaTime = requesttime - g_lastTime;
	g_lastTime  = requesttime;
	if (deltaTime > 0)
		g_fps = 0.8 * g_fps + 200.0 / deltaTime;

	if (g_UseWS) {
		requestImage(function(img) {
			if (img) {
				$('#img1').attr("src", img);
				var requestdelay = ( new Date() ).getTime() - requesttime;
				var nextupdate = g_cameraImgPeriod - requestdelay;
				if (nextupdate < 0)
					nextupdate = 0;
				if (g_imageUpdating)
					window.setTimeout(updateImage, nextupdate);
			}
			else {
				window.setTimeout(updateImage, 500);
			}
		});
	}
	else {
		var image = new Image();
		$(image).attr("id","img"+g_toshow);
		$(image).attr("onerror","onConnectionLoss();");
		g_imageCurrentURL = "picture.jpg" + "?rnd=" + Math.floor(Math.random() * 1000000);
		$(image)
			.load(function () {
				$('#img' + g_tohide).hide();
				$('#loader').append(this);
				$(this).show();
				$('#img' + g_tohide).remove();
				g_tohide = (g_tohide === 1) ? 0 : 1;
				g_toshow = (g_toshow === 1) ? 0 : 1;
				var requestdelay = ( new Date() ).getTime() - requesttime;
				var nextupdate = g_cameraImgPeriod - requestdelay;
				if (nextupdate < 0)
					nextupdate = 0;
				if (g_imageUpdating)
					window.setTimeout(updateImage, nextupdate);
			})
			.attr("src", g_imageCurrentURL);
	}
}

$(function () {
	g_UseWS = isWebSocketSupported();
	setWSConnectionLossCallback(onConnectionLoss);
});
